/*

Class That Displays Load Or Save Dialog Box

Author :	Dattaraj J. Rao
			jagrao@goa1.dot.net.in

*/

import java.awt.*;
import java.io.*;

class LSDialog
{
	final static int LOAD=0;
	final static int SAVE=1;

	FileDialog fd;
	int mode;
	TextArea output;
	Alert alert;
	Frame parent;

	public LSDialog()
	{
	}

	public LSDialog(Frame fr,TextArea txt)
	{
		output=txt;
		parent=fr;
		alert=new Alert(parent,"Error",true);
	}

	// To cause Save dialog box
	public void save(String str,String ext)
	{
		fd=new FileDialog(parent,str,SAVE);
		mode=SAVE;
		display(ext);
	}

	// To cause Load dialog box
	public void load(String str,String ext)
	{
		fd=new FileDialog(parent,str,LOAD);
		mode=LOAD;
		display(ext);
	}

	void display(String ext)
	{
		fd.setFile("*."+ext);
		fd.setVisible(true);
		
		if(fd.getFile()==null || fd.getDirectory()==null)
			return;
		String file=fd.getDirectory()+"\\"+fd.getFile();
		
		switch(mode)
		{
			case LOAD:
				doLoad(file);
				break;
			case SAVE:
				doSave(file);
				break;
		}
	}

	void doSave(String file)
	{
		BufferedWriter out;
		try
		{
			out=new BufferedWriter(new FileWriter(file));
			out.write(output.getText());
			out.close();
		}
		catch(IOException e)
		{
			alert.doAlert("Error Saving File");
		}
	}

	void doLoad(String file)
	{
		BufferedReader in;
		try
		{
			in=new BufferedReader(new FileReader(file));
			String temp;

			output.setText("");

			while((temp=in.readLine())!=null)
				output.append(temp+"\n");
			
			in.close();
		}
		catch(Exception exp1)
		{
			alert.doAlert("Error Loading File");
		}
	}

}