/*

Results Frame That Displays Output Of Query

Author :	Dattaraj J. Rao
			jagrao@goa1.dot.net.in

*/

import java.awt.*;
import java.awt.event.*;
import java.sql.*;
import java.util.*;
import java.io.*;

class Results extends Frame implements WindowListener,ActionListener
{
	int i,cols;
	final int records=10;
	boolean hasrecords=true;
	Vector columns;
	String windowtitle;

	ResultSet results;
	ResultSetMetaData rma;

	MenuItem next,save,open,exit;
	TextArea output;
	Alert alert;
	LSDialog dialog;

	public Results()
	{
	}

	public Results(String title)
	{
		super(title);
		windowtitle=title;

		Image icon=getToolkit().getImage("icon.gif");
		setIconImage(icon);

		output=new TextArea();
		output.setEditable(true);
		add(output);
		addWindowListener(this);
		setBounds(50,20,600,500);

		MenuBar mbar=new MenuBar();
		setMenuBar(mbar);

		// File Menu
		Menu file=new Menu("File");
		mbar.add(file);

		save=new MenuItem("Save To File",new MenuShortcut('S'));
		save.addActionListener(this);
		file.add(save);

		open=new MenuItem("Open File",new MenuShortcut('O'));
		open.addActionListener(this);
		file.add(open);

		file.add(new MenuItem("-"));

		exit=new MenuItem("Exit",new MenuShortcut('X'));
		exit.addActionListener(this);
		file.add(exit);

		//Query Menu
		Menu query=new Menu("Query");
		mbar.add(query);

		next=new MenuItem("Next 10 Matches",new MenuShortcut('N'));
		next.addActionListener(this);
		query.add(next);

		//Dialog box
		alert=new Alert(this,"Error",true);
		hasrecords=true;

		dialog=new LSDialog(this,output);
	}
		
	public void showResults(ResultSet res)
	{
		try
		{
			results=res;
			columns=new Vector();
			rma=res.getMetaData();
			cols=rma.getColumnCount();

			for(i=1;i<=cols;i++)
			{
				columns.addElement(rma.getColumnName(i));
			}
			output.setText("");
			output.append("\n---------------------------------------------------------------------\n");

			displayNext();								
		}
		catch(Exception exp1)
		{
		}
	}
	
	void displayNext()
	{
		int j=0;
		try
		{
			while( j<records )
			{
				hasrecords=results.next();
				if(!hasrecords)
					break;

				for(i=1;i<=cols;i++)
				{
					output.append((String)columns.elementAt(i-1) + "\t\t" +
						results.getString((String)columns.elementAt(i-1))+"\n");
				}
				output.append("\n---------------------------------------------------------------------\n");
				j++;
			}
		}
		catch(Exception exp1)
		{
		}

		if(hasrecords)
		{
			next.setEnabled(hasrecords);
			setTitle( windowtitle + " : More Matches Exist");
		}
		else
		{
			setTitle(windowtitle);
		}

		setVisible(true);
		requestFocus();
	}

	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource()==save)
			dialog.save("Save Query Results","txt");
		if(e.getSource()==open)
			dialog.load("Load File","txt");
		if(e.getSource()==exit)
			setVisible(false);

		if(e.getSource()==next)
			displayNext();
	}

	public void windowClosing(WindowEvent e)
	{
		setVisible(false);
	}

	public void windowClosed(WindowEvent e){ }
	public void windowOpened(WindowEvent e){ }
	public void windowIconified(WindowEvent e){ }
	public void windowDeiconified(WindowEvent e){ }
	public void windowActivated(WindowEvent e){ }
	public void windowDeactivated(WindowEvent e){ }


};