/*

Main Frame Where Data Source Name Is Entered

Author :	Dattaraj J. Rao
			jagrao@goa1.dot.net.in

*/

import java.awt.*;
import java.awt.event.*;
import java.sql.*;

class SourceFrame extends Frame implements ActionListener,WindowListener,KeyListener
{
	TextField source;
	Label enter,message;
	Button check;
	Alert alert;

	Connection conn;

	public SourceFrame()
	{
	}

	public SourceFrame(String title)
	{
		super(title);

		addWindowListener(this);

		Image icon=getToolkit().getImage("icon.gif");
		setIconImage(icon);

		enter=new Label("Enter The Name Of The ODBC Data Source");
		source=new TextField(30);
		source.addKeyListener(this);
		check=new Button("      Start      ");
		check.setFont(new Font("",Font.BOLD,20));
		check.addActionListener(this);
		message=new Label("By Dattaraj J. Rao",Label.CENTER);
		message.setFont(new Font("",Font.BOLD,15));
		message.setBackground(Color.white);

		Panel pane=new Panel();
		pane.setLayout(new FlowLayout(FlowLayout.CENTER,100,10));
		pane.add(enter);
		pane.add(source);
		pane.add(check);

		setLayout(new BorderLayout());
		add("Center",pane);
		add("South",message);

		alert=new Alert(this,"Error Connecting ...",true);

		setBounds(150,150,500,200);
		setVisible(true);
	}

	boolean validate(String datasource)
	{
		message.setText("Trying To Connect To Data source . . .");
		try
		{
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			String url="jdbc:odbc:" + datasource;
			conn=DriverManager.getConnection(url);
		}
		catch(Exception exp1)
		{
			message.setText("Error Connecting To data Source");
			return false;
		}

		if(conn==null)
		{
			message.setText("Error Connecting To data Source");
			return false;
		}
		
		return true;
	}


	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource()==check)
		{
			if(validate(source.getText()))
			{
				setVisible(false);
				DBaseFrame frm1=new DBaseFrame("SQL Tester",conn);
			}
		}			
	}

	public void keyPressed(KeyEvent e)
	{
		if(e.getKeyCode()==KeyEvent.VK_ENTER)
		{
			if(validate(source.getText()))
			{
				setVisible(false);
				DBaseFrame frm1=new DBaseFrame("SQL Tester",conn);
			}
		}			
	}

	public void keyReleased(KeyEvent e){ }
	public void keyTyped(KeyEvent e)
	{ 
		if(e.getSource()==source)
			message.setText("By Dattaraj J. Rao");
	}

	public void windowClosing(WindowEvent e)
	{
		System.exit(0);
	}

	public void windowClosed(WindowEvent e){ }
	public void windowOpened(WindowEvent e){ }
	public void windowIconified(WindowEvent e){ }
	public void windowDeiconified(WindowEvent e){ }
	public void windowActivated(WindowEvent e){ }
	public void windowDeactivated(WindowEvent e){ }

}
